
var popup =
{
	init : function()
	{
		this.replace();
		this.currentItem  = document.getElementById('x11colorCurrent');
		this.popColorList = document.getElementById('x11colorList');
	},
	
	blur : function(e)
	{
		if (e.target == this.popColorList) return;
		else if (e.target == this.currentItem) return;
		else if (e.keyCode && e.keyCode != 27) return;
		this.popColorList.style.display = 'none';
	},
	
	up : function()
	{
		var disp = this.popColorList.style.display;
		this.popColorList.style.display = (disp == 'block' ? 'none' : 'block');
		this.currentItem.blur(); if (this.selectedItem)
		document.getElementById(this.selectedItem.id).focus();
	},
	
	sel : function(button)
	{
		this.popColorList.style.display = 'none';
		this.selected(button.id);
		d.CP['x11'+_bcSt+'Name'].value = button.firstChild.data;
		_x11color.input(_bcSt); if (this.selectedItem)
		document.getElementById(this.selectedItem.id).blur();
		document.getElementById(this.currentItem.id).focus();
	},
	
	selected : function(id)
	{
		if (!id) {
			this.currentItem.style.color      = 'white';
			this.currentItem.style.background = 'white';
			this.currentItem.firstChild.data  = '\xA0';
			return;
		}
		var button = document.getElementById(id);
		this.currentItem.style.color      = button.style.color;
		this.currentItem.style.background = button.style.background;
		this.currentItem.firstChild.data  = button.firstChild.data;
		this.selectedItem = button;
	},
	
	replace : function()
	{
		var select = document.getElementById('x11colorSelect');
		cDIV = document.createElement('div');
		cUL  = document.createElement('ul');
		for (var i=1; i<select.options.length; i++)
		{
			opt = select.options[i];
			cLI = document.createElement('li');
			cBT = document.createElement('button');
			cBT.id = opt.id;
			cBT.style.color = opt.style.color;
			cBT.style.background = opt.style.background;
			cBT.addEventListener('click', function(){ popup.sel(this) }, false);
			cBT.addEventListener('keydown', function(){ popup.blur(arguments[0]) }, false);
			cBT.appendChild( document.createTextNode(opt.text) );
			cLI.appendChild(cBT); cUL.appendChild(cLI);
		}
		cBT = document.createElement('button')
		cDIV.id = 'x11colorContainer';
		cUL.id  = 'x11colorList';
		cBT.id  = 'x11colorCurrent';
		cBT.appendChild( document.createTextNode('White') ); cDIV.appendChild(cUL);
		select.parentNode.setAttribute('for', 'borc');
		select.parentNode.removeAttribute('accesskey');
		select.parentNode.replaceChild(cBT, select);
		cBT.parentNode.parentNode.appendChild(cDIV);
		cBT.addEventListener('click', function(){ popup.up() }, false);
		document.addEventListener('click', function(){ popup.blur(arguments[0]) }, false);
	}
};

